local mod = ...



-- mod:registerAssetId("models/Terrain1.fbx/Materials/Material.Water", "MATERIAL_TERRAIN_WATER")
-- mod:override({
-- 	Id = "MATERIAL_TERRAIN_WATER",
-- 	HasAlphaTest = true
-- })


-- Materials -------------------------------------------------------------------------------------
mod:registerAssetId("models/Terrace2.fbx/Materials/Material.Dark", "MATERIAL_TERRAIN_DARK")
mod:registerAssetId("models/Terrace2.fbx/Materials/Material.Grass", "MATERIAL_TERRAIN_GRASS")
mod:registerAssetId("models/Terrace2.fbx/Materials/Material.Light", "MATERIAL_TERRAIN_LIGHT")
mod:registerAssetId("models/Terrace2.fbx/Materials/Material.Rock", "MATERIAL_TERRAIN_ROCK")
mod:registerAssetId("models/Terrace2.fbx/Materials/Material.Transparent", "MATERIAL_TERRAIN_TRANSPARENT")
mod:registerAssetId("models/Piling2.fbx/Materials/Material.Transparent", "MATERIAL_TERRAIN_PILING_TRANSPARENT")


mod:override({
	Id = "MATERIAL_TERRAIN_TRANSPARENT",
	HasAlphaTest = true
})


mod:override({
	Id = "MATERIAL_TERRAIN_PILING_TRANSPARENT",
	HasAlphaTest = true
})



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Terrace2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Piling2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Loop count -------------------------------------------------------------------------------------
_countHill = 15
_countCliff = 5
_countTerrace = 3
_countWall = 4
_countTerraceNew = 3
_countStair = 1
_countStairNew = 3
_countPiling = 3
_countPilingNew = 4



-- Tiling Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Terrace2.fbx/Prefab/TilingPart", "PREFAB_TERRAIN_TILING")



-- Tiling part -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TERRAIN_TILING",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TERRAIN_TILING"
	}
})



-- Function: Terrain -------------------------------------------------------------------------------------
function registerTerrain(_name)

	mod:registerAssetId("models/Terrain1.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
	mod:registerPrefabComponent("models/Terrain1.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Terrain1.fbx/Prefab/" .. _name, { "TERRAIN" })
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name,
		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
		-- Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
		}
	})

end



-- Function: Terrace (Old - for saved games) -------------------------------------------------------------------------------------
function registerTerrace(_name)

	mod:registerAssetId("models/Terrace1.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
	mod:registerPrefabComponent("models/Terrace1.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Terrace1.fbx/Prefab/" .. _name, { "TERRAIN" })
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name,
		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
		Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
		}
	})

end



-- Function: Terrace New -------------------------------------------------------------------------------------
function registerTerraceNew(_name1, _name2, _name3, _name4)

	mod:registerAssetId("models/Terrace2.fbx/Prefab/" .. _name1, "PREFAB_BUILDING_PART_TERRAIN_" .. _name2)
	mod:registerAssetId("models/Terrace2.fbx/Prefab/Root" .. _name1, "PREFAB_BUILDING_PART_TERRAIN_ROOT_" .. _name2)
	mod:registerPrefabComponent("models/Terrace2.fbx/Prefab/" .. _name1, { DataType = "COMP_BUILDING_PART" })
	mod:registerPrefabComponent("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name2, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name2, { "TERRAIN" })
	mod:registerPrefabComponent("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name3, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name3, { "TERRAIN" })
	mod:registerPrefabComponent("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name4, { DataType = "COMP_RIGID_BODY", Mass = 0 }) -- added these Unified objects to try to improve pathing errors
	mod:configurePrefabFlagList("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name4, { "TERRAIN" })

		-- mod:register({
	-- 	DataType = "BUILDING_PART",
	-- 	Id = "BUILDING_PART_TERRAIN_" .. _name2,
	-- 	Name = "BUILDING_PART_TERRAIN_" .. _name2 .. "_NAME", 
	-- 	Category = "CORE", 
	-- 	ConstructorData = {
	-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
	-- 		CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name2
	-- 	}
	-- })

	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_END_" .. _name2,
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name2
		}
	})
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name2,
		Name = "BUILDING_PART_TERRAIN_" .. _name2 .. "_NAME", 
		-- Category = "CORE", 
		-- ConstructorData = {
		-- 	DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		-- 	CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name2
		-- }
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_SCALER",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_ROOT_" .. _name2,
			EndPart =  "BUILDING_PART_TERRAIN_END_" .. _name2,
			FillerList = {
				"BUILDING_PART_TERRAIN_TILING"
			},
			BasementFillerList = nil,
			MinimumScale = 0,
			IsVertical = true
		}
	})
	
end



-- Function: Stair -------------------------------------------------------------------------------------
function registerStair(_name)

	mod:registerAssetId("models/Terrace2.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
	mod:registerPrefabComponent("models/Terrace2.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Terrace2.fbx/Prefab/" .. _name, { "TERRAIN" })
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name,
		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
		-- Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
		}
	})
	
end



-- Function: Stair New -------------------------------------------------------------------------------------
function registerStairNew(_name1, _name2)

	mod:registerAssetId("models/Terrace2.fbx/Prefab/" .. _name1, "PREFAB_BUILDING_PART_TERRAIN_" .. _name2)
	mod:registerAssetId("models/Terrace2.fbx/Prefab/Root" .. _name1, "PREFAB_BUILDING_PART_TERRAIN_ROOT_" .. _name2)
	mod:registerPrefabComponent("models/Terrace2.fbx/Prefab/" .. _name1, { DataType = "COMP_BUILDING_PART" })
	mod:registerPrefabComponent("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name2, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name2, { "TERRAIN" })

	if (_name2 == "STAIRNEW3") then -- invisible ladder platform
		mod:registerPrefabComponent("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name2 .. "PLATFORM", { DataType = "COMP_RIGID_BODY", Mass = 0 })
		mod:configurePrefabFlagList("models/Terrace2.fbx/Prefab/" .. _name1 .. "/" .. _name2 .. "PLATFORM", { "TERRAIN" })
	end

	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_END_" .. _name2,
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name2
		}
	})
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name2,
		Name = "BUILDING_PART_TERRAIN_" .. _name2 .. "_NAME", 
		-- Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_SCALER",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_ROOT_" .. _name2,
			EndPart =  "BUILDING_PART_TERRAIN_END_" .. _name2,
			FillerList = {
				"BUILDING_PART_TERRAIN_TILING"
			},
			BasementFillerList = nil,
			MinimumScale = 0,
			IsVertical = true
		}
	})
	
end


-- Function: Piling -------------------------------------------------------------------------------------
function registerPiling(_name)

	mod:registerAssetId("models/Piling1.fbx/Prefab/" .. _name, "PREFAB_BUILDING_PART_TERRAIN_" .. _name)
	mod:registerPrefabComponent("models/Piling1.fbx/Prefab/" .. _name, { DataType = "COMP_GROUNDED", GroundToWater = true })
	mod:registerPrefabComponent("models/Piling1.fbx/Prefab/" .. _name, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Piling1.fbx/Prefab/" .. _name, { "TERRAIN" })
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name,
		Name = "BUILDING_PART_TERRAIN_" .. _name .. "_NAME", 
		-- Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name
		},
		IsMovableWhenBuilt = true
	})
	
end



-- Function: Piling New -------------------------------------------------------------------------------------
function registerPilingNew(_name1, _name2, _name3)

	mod:registerAssetId("models/Piling2.fbx/Prefab/" .. _name1, "PREFAB_BUILDING_PART_TERRAIN_" .. _name2)
	mod:registerPrefabComponent("models/Piling2.fbx/Prefab/" .. _name1, { DataType = "COMP_BUILDING_PART" })
	mod:registerPrefabComponent("models/Piling2.fbx/Prefab/" .. _name1, { DataType = "COMP_GROUNDED", GroundToWater = true })
	mod:registerPrefabComponent("models/Piling2.fbx/Prefab/" .. _name1 .. "/" .. _name2, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Piling2.fbx/Prefab/" .. _name1 .. "/" .. _name2, { "TERRAIN" })
	mod:registerPrefabComponent("models/Piling2.fbx/Prefab/" .. _name1 .. "/" .. _name3, { DataType = "COMP_RIGID_BODY", Mass = 0 })
	mod:configurePrefabFlagList("models/Piling2.fbx/Prefab/" .. _name1 .. "/" .. _name3, { "TERRAIN" })
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_TERRAIN_" .. _name2,
		Name = "BUILDING_PART_TERRAIN_" .. _name2 .. "_NAME", 
		-- Category = "CORE", 
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_TERRAIN_" .. _name2
		}
	})
	
end



-- Loop -------------------------------------------------------------------------------------
for i= 1, _countHill do
	registerTerrain("HILL" .. i)
end

for i= 1, _countCliff do
	registerTerrain("CLIFF" .. i)
end

for i= 1, _countTerrace do
	registerTerrace("TERRACE" .. i)
end

for i= 1, _countWall do
	registerTerrace("WALL" .. i)
end

for i= 1, _countTerraceNew do
	registerTerraceNew("TerracePart" .. i, "TERRACENEW" .. i, "WALLNEW" .. i, "UNIFIED" .. i)
end

for i= 1, _countStair do
	registerStair("STAIR" .. i)
end

for i= 1, _countStairNew do
	registerStairNew("StairPart" .. i, "STAIRNEW" .. i)
end

for i= 1, _countPiling do
	registerPiling("PILING" .. i)
end

for i= 1, _countPilingNew do
	registerPilingNew("PilingPart" .. i, "PILINGNEW" .. i, "BLOCK" .. i)
end



-- Building: Terrain -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_TERRAIN",
	Name = "BUILDING_TERRAIN_NAME",
	Description = "BUILDING_TERRAIN_DESC",
	BuildingType = "DECORATION",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_TERRAIN3_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_TERRACENEW1",
				"BUILDING_PART_TERRAIN_TERRACENEW2",
				"BUILDING_PART_TERRAIN_TERRACENEW3",
				"BUILDING_PART_TERRAIN_STAIRNEW2",
				"BUILDING_PART_TERRAIN_STAIRNEW1",
				"BUILDING_PART_TERRAIN_STAIRNEW3",
			}
		},
		{
			Name = "BUILDING_SET_TERRAIN4_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_PILINGNEW1",
				"BUILDING_PART_TERRAIN_PILINGNEW2",
				"BUILDING_PART_TERRAIN_PILINGNEW3",
				-- "BUILDING_PART_TERRAIN_PILINGNEW4", -- this bridge piece would never work, it seemed it was too small to count as terrain
			}
		},
		{
			Name = "BUILDING_SET_TERRAIN1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_HILL1",
				"BUILDING_PART_TERRAIN_HILL2",
				"BUILDING_PART_TERRAIN_HILL3",
				"BUILDING_PART_TERRAIN_HILL4",
				"BUILDING_PART_TERRAIN_HILL5",
				"BUILDING_PART_TERRAIN_HILL6",
				"BUILDING_PART_TERRAIN_HILL7",
				"BUILDING_PART_TERRAIN_HILL8",
				"BUILDING_PART_TERRAIN_HILL9",
				"BUILDING_PART_TERRAIN_HILL10",
				"BUILDING_PART_TERRAIN_HILL11",
				"BUILDING_PART_TERRAIN_HILL12",
				"BUILDING_PART_TERRAIN_HILL13",
				"BUILDING_PART_TERRAIN_HILL14",
				"BUILDING_PART_TERRAIN_HILL15",
			}
		},
		{
			Name = "BUILDING_SET_TERRAIN2_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TERRAIN_CLIFF1",
				"BUILDING_PART_TERRAIN_CLIFF2",
				"BUILDING_PART_TERRAIN_CLIFF3",
				"BUILDING_PART_TERRAIN_CLIFF4",
				"BUILDING_PART_TERRAIN_CLIFF5",
			}
		},
	},	
	RequiredPartList = {
	},
	IsEditable = true,
	MaterialSetList = {
		{
			SetName = "MATERIAL_SET_TERRAIN1_NAME",
			MaterialList = {
				"MATERIAL_TERRAIN_GRASS",
				"MATERIAL_TERRAIN_ROCK",
			}
		},
		{
			SetName = "MATERIAL_SET_TERRAIN2_NAME",
			MaterialList = {
				"MATERIAL_TERRAIN_DARK",
				"MATERIAL_TERRAIN_ROCK",
			}
		},
		{
			SetName = "MATERIAL_SET_TERRAIN3_NAME",
			MaterialList = {
				"MATERIAL_TERRAIN_LIGHT",
				"MATERIAL_TERRAIN_ROCK",
			}
		},
	}
})


